<template>
  <section
    :class="componentClasses"
    :id="id"
    class="ContentSection"
  >
    <header
      v-if="isSlotFilled('header') === true"
      class="ContentSection-header"
    >
      <slot name="header" />
    </header>

    <div
      v-if="isSlotFilled('default') === true"
      class="ContentSection-main"
    >
      <slot />
    </div>

    <footer
      v-if="isSlotFilled('footer') === true"
      class="ContentSection-footer"
    >
      <slot name="footer" />
    </footer>
  </section>
</template>

<script>
import { upperFirst } from 'lodash/string'

function isValidSpacing(value) {
  const validValues = [
    'none',
    'xs',
    'sm',
    'md',
    'lg',
    'xl'
  ]

  return validValues.indexOf(value) !== -1
}

export default {
  name: 'ContentSection',

  props: {
    /**
     * The border of the content section.
     */
    border: {
      type: String,
      default: undefined,
      validator(value) {
        const validValues = [
          'solid'
        ]

        return validValues.indexOf(value) !== -1
      }
    },

    outerSpacingHorizontal: {
      type: String,
      default: undefined,
      validator(value) {
        const validValues = [
          'none'
        ]

        return validValues.indexOf(value) !== -1
      }
    },

    /**
     * The id of the content section.
     */
    id: {
      type: String,
      default: undefined
    },

    /**
     * The space after the content section.
     */
    spaceAfter: {
      type: String,
      default: 'md',
      validator: isValidSpacing
    },

    /**
     * The space before the content section.
     */
    spaceBefore: {
      type: String,
      default: 'md',
      validator: isValidSpacing
    }
  },

  computed: {
    componentClasses () {
      const classes = []

      if (this.border !== undefined) {
        classes.push(`${this.$options.name}--border${upperFirst(this.border)} `)
      }
      if (this.outerSpacingHorizontal !== undefined) {
        classes.push(`${this.$options.name}--outerSpacingHorizontal${upperFirst(this.outerSpacingHorizontal)} `)
      }
      if (this.spaceAfter !== undefined) {
        classes.push(`${this.$options.name}--spaceAfter${upperFirst(this.spaceAfter)} `)
      }
      if (this.spaceBefore !== undefined) {
        classes.push(`${this.$options.name}--spaceBefore${upperFirst(this.spaceBefore)} `)
      }

      return classes
    }
  },

  methods: {
    isSlotFilled(slotName) {
      return this.$slots[ slotName ] !== undefined
    }
  }
}
</script>

<style scoped>
.ContentSection {
  display: grid;
  grid-template-columns: 100%;
  grid-template-rows: auto;
  grid-row-gap: 15px;
  margin-top: 0;
  margin-bottom: 0;
  padding: 0 15px;
  border-color: lightgrey;
  border-width: 0;
  border-style: solid;
}

.ContentSection-header {
  display: block;
}

.ContentSection-main {
  display: block;
}

.ContentSection-footer {
  display: block;
}

.ContentSection--borderSolid {
  padding: 15px;
  margin-left: 15px;
  margin-right: 15px;
  border-width: 2px;
}

.ContentSection--outerSpacingHorizontalNone {
  padding-left: 0;
  padding-right: 0;
}

.ContentSection--spaceAfterXs {
  margin-bottom: 10px;
}

.ContentSection--spaceBeforeXs {
  margin-top: 10px;
}

.ContentSection--spaceAfterSm {
  margin-bottom: 25px;
}

.ContentSection--spaceBeforeSm {
  margin-top: 25px;
}

.ContentSection--spaceAfterMd {
  margin-bottom: 50px;
}

.ContentSection--spaceBeforeMd {
  margin-top: 50px;
}

.ContentSection--spaceAfterLg {
  margin-bottom: 100px;
}

.ContentSection--spaceBeforeLg {
  margin-top: 100px;
}

.ContentSection--spaceAfterXl {
  margin-bottom: 150px;
}

.ContentSection--spaceBeforeXl {
  margin-top: 150px;
}
</style>
